import { faTiktok, faYoutube, faInstagram } from '@fortawesome/free-brands-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';
import { fas } from '@fortawesome/free-solid-svg-icons';
import Router from './router';
import './styles/Campaign.scss';
import '@/styles/custom-theme.scss';
import { Chart as ChartJS, ArcElement, Tooltip, Legend, BarElement, LinearScale, CategoryScale, LineElement, PointElement } from 'chart.js';
import NotificationBar from './components/NotificationBar';

ChartJS.register(ArcElement, Tooltip, Legend, BarElement, LinearScale, CategoryScale, LineElement, PointElement);

// Add Font Awesome icons to library
library.add(faTiktok, fas, faYoutube, faInstagram);

function App() {
    return (
        <>
            <Router />
            <NotificationBar />
        </>
    );
}

export default App;
