import { ChartNoAxesColumnIncreasing, CircleDollarSign, Edit, Eye, Folders, Hash, Layers, Tag, TrendingUp, UserRoundCheck } from 'lucide-react';
import { useSelector } from 'react-redux';

export default function CampaignInfo() {
    const { currentCampaign } = useSelector((state) => state.campaign);
    return (
        <div className='campaign-detail-info shadow-xs'>
            <div className='campaign-info-top'>
                <div className='campaign-name'>{currentCampaign.name}</div>
                <div className='campaign-descp'>{currentCampaign.description || '--'}</div>
                <div className='campaign-edit'>
                    <Edit size={18} />
                    Edit
                </div>
            </div>
            <div className='campaign-info-bottom'>
                <div className='campaign-info-item'>
                    <div className='campaign-info-item-label'>
                        <Layers size={18} />
                        Service
                    </div>
                    <div className='campaign-info-item-value'>{currentCampaign?.service || '--'}</div>
                </div>
                <div className='campaign-info-item'>
                    <div className='campaign-info-item-label'>
                        <Folders size={18} />
                        Category
                    </div>
                    <div className='campaign-info-item-value'>
                        {currentCampaign?.creator_category || '--'}
                        {/* {currentCampaign?.category?.length > 0 &&
                            currentCampaign.category.map((cat,index) => <span className='category-tag' key={index}>{cat}</span>)} */}
                    </div>
                </div>
                <div className='campaign-info-item'>
                    <div className='campaign-info-item-label'>
                        <UserRoundCheck size={18} />
                        Followers
                    </div>
                    <div className='campaign-info-item-value'>{currentCampaign?.followers || '--'}</div>
                </div>
                <div className='campaign-info-item'>
                    <div className='campaign-info-item-label'>
                        <Tag size={18} />
                        Creator Category
                    </div>
                    <div className='campaign-info-item-value'>{currentCampaign?.creator_category || '--'}</div>
                </div>
                <div className='campaign-info-item'>
                    <div className='campaign-info-item-label'>
                        <TrendingUp size={18} />
                        GMV
                    </div>
                    <div className='campaign-info-item-value'>{currentCampaign?.gmv || '--'}</div>
                </div>
                <div className='campaign-info-item'>
                    <div className='campaign-info-item-label'>
                        <CircleDollarSign size={18} />
                        Pricing
                    </div>
                    <div className='campaign-info-item-value'>{currentCampaign?.budget || '--'}</div>
                </div>
                <div className='campaign-info-item'>
                    <div className='campaign-info-item-label'>
                        <ChartNoAxesColumnIncreasing size={18} />
                        Creator Level
                    </div>
                    <div className='campaign-info-item-value'>
                        {currentCampaign?.creator_level || '--'}
                        {/* {currentCampaign?.creator_level?.length > 0 &&
                            currentCampaign.creator_level.map((level,index) => (
                                <span className='creator-level-tag' key={index}>{level}</span>
                            ))} */}
                    </div>
                </div>
                <div className='campaign-info-item'>
                    <div className='campaign-info-item-label'>
                        <Eye size={18} />
                        Views
                    </div>
                    <div className='campaign-info-item-value'>{currentCampaign?.views || '--'}</div>
                </div>
                <div className='campaign-info-item'>
                    <div className='campaign-info-item-label'>
                        <Hash size={18} />
                        Creators
                    </div>
                    <div className='campaign-info-item-value'>{currentCampaign?.creators_count || '--'}</div>
                </div>
            </div>
        </div>
    );
}
