import { Check, CircleAlert, Info, ShieldAlert, X } from 'lucide-react';
import { useDispatch, useSelector } from 'react-redux';
import { resetNotificationBar } from '../store/slices/notificationBarSlice';
import { useEffect } from 'react';
import { Alert } from 'react-bootstrap';

export default function NotificationBar() {
    const { message, type, show } = useSelector((state) => state.notificationBar);
    const dispatch = useDispatch();

    const setTimeOut = () => {
        setTimeout(() => {
            dispatch(resetNotificationBar());
        }, 3000);
    };

    const handleClose = () => {
        dispatch(resetNotificationBar());
    };

    useEffect(() => {
        setTimeOut();
    }, [message]);

    return (
        show && (
            <Alert
                role='alert'
                variant={type === 'error' ? 'danger' : type}
                style={{ zIndex: 999999, top: '10%', position: 'fixed', left: '50%', width: '60%', transform: 'translateX(-50%)', display: 'flex' }}
            >
                {type === 'success' && <Check />}
                {type === 'warning' && <CircleAlert />}
                {type === 'error' && <ShieldAlert />}
                {type === 'info' && <Info />}
                <div className='flex-fill'>{message}</div>
            </Alert>
        )
    );
}
