import { useState } from "react";
import { Form, InputGroup } from "react-bootstrap";

export default function SearchBar({ onSearch, value, onChange }) {
	const handleSearch = (e) => {
		e.preventDefault();
		onSearch(e);
	};

    return (
        <Form onSubmit={handleSearch} className='search-bar'>
            <InputGroup>
                <Form.Control type='text' list='datalistOptions' placeholder='Search' value={value} onChange={onChange} />
            </InputGroup>
            <datalist id='datalistOptions'>
                <option value='San Francisco' />
                <option value='New York' />
                <option value='Seattle' />
                <option value='Los Angeles' />
                <option value='Chicago' />
            </datalist>
        </Form>
    );
}
