import React, { useEffect, useState } from 'react';
import InboxList from '@/components/InboxList';
import ChatWindow from '@/components/ChatWindow';
import '@/styles/Inbox.scss';
import { useSelector, useDispatch } from 'react-redux';
import { resetSelectedChat } from '@/store/slices/chatSlice';
import ChatDetails from '@/components/ChatDetails';

export default function CreatorInbox() {
    const { currentChat } = useSelector((state) => state.chat);
    const [openChatDetails, setOpenChatDetails] = useState(false);

    const dispatch = useDispatch();
    useEffect(() => {
        return () => {
            dispatch(resetSelectedChat());
        };
    }, []);

    useEffect(() => {}, [currentChat]);

    return (
        <React.Fragment>
            <InboxList />
            {currentChat?.conversation_id && <ChatWindow onOpenChatDetails={() => setOpenChatDetails(true)} />}
            {openChatDetails && <ChatDetails onCloseChatDetails={() => setOpenChatDetails(false)} />}
        </React.Fragment>
    );
}
